/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.spagosoa.smx.listeners.feeders;

import it.eng.spagosoa.metadb.model.ExternalDataFeeder;

import org.hibernate.Session;

public class DataFeederFactory {

    private static DataFeederFactory _instance = null;
    

    private DataFeederFactory(Session aSession) throws Exception {

    }
    
    public static DataFeederFactory getInstance(Session aSession) {
        if (_instance == null) {
            synchronized (DataFeederFactory.class) {
                if (_instance == null) {
                    try {
                        _instance = new DataFeederFactory(aSession);
                    } // try
                    catch (Exception ex) {
                        System.out
                                .println("FeederFactory::getInstance: errore creazione factory");
                        ex.printStackTrace();
                    } // catch(Exception ex) try
                } // if (_instance == null)
            } // synchronized(FeederFactory.class)
        } // if (_instance == null)
        return _instance;
    } // public static FeederFactory getInstance()

	public IDataFeeder getFeeder(Session aSession, ExternalDataFeeder externalDataFeeder) {
		// Retrieve feeder class name from database
		String feederClass = externalDataFeeder.getAdditionalInfo();
		
		IDataFeeder feeder = null;
        try {
        	feeder = (IDataFeeder)Class.forName(feederClass).newInstance();
        } // try
        catch (Exception ex) {
        	// TODO
        	ex.printStackTrace();
        } // catch (Exception ex) try
        return feeder;
	}
}
